/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the WriterDebugResponseAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WriterDebugResponseAllOf{}

// WriterDebugResponseAllOf struct for WriterDebugResponseAllOf
type WriterDebugResponseAllOf struct {
	ConnectionResult NullableOneOfConnectionResult `json:"connectionResult,omitempty"`
}

// NewWriterDebugResponseAllOf instantiates a new WriterDebugResponseAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWriterDebugResponseAllOf() *WriterDebugResponseAllOf {
	this := WriterDebugResponseAllOf{}
	return &this
}

// NewWriterDebugResponseAllOfWithDefaults instantiates a new WriterDebugResponseAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWriterDebugResponseAllOfWithDefaults() *WriterDebugResponseAllOf {
	this := WriterDebugResponseAllOf{}
	return &this
}

// GetConnectionResult returns the ConnectionResult field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *WriterDebugResponseAllOf) GetConnectionResult() OneOfConnectionResult {
	if o == nil || IsNil(o.ConnectionResult.Get()) {
		var ret OneOfConnectionResult
		return ret
	}
	return *o.ConnectionResult.Get()
}

// GetConnectionResultOk returns a tuple with the ConnectionResult field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *WriterDebugResponseAllOf) GetConnectionResultOk() (*OneOfConnectionResult, bool) {
	if o == nil {
		return nil, false
	}
	return o.ConnectionResult.Get(), o.ConnectionResult.IsSet()
}

// HasConnectionResult returns a boolean if a field has been set.
func (o *WriterDebugResponseAllOf) HasConnectionResult() bool {
	if o != nil && o.ConnectionResult.IsSet() {
		return true
	}

	return false
}

// SetConnectionResult gets a reference to the given NullableOneOfConnectionResult and assigns it to the ConnectionResult field.
func (o *WriterDebugResponseAllOf) SetConnectionResult(v OneOfConnectionResult) {
	o.ConnectionResult.Set(&v)
}

// SetConnectionResultNil sets the value for ConnectionResult to be an explicit nil
func (o *WriterDebugResponseAllOf) SetConnectionResultNil() {
	o.ConnectionResult.Set(nil)
}

// UnsetConnectionResult ensures that no value is present for ConnectionResult, not even an explicit nil
func (o *WriterDebugResponseAllOf) UnsetConnectionResult() {
	o.ConnectionResult.Unset()
}

func (o WriterDebugResponseAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WriterDebugResponseAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.ConnectionResult.IsSet() {
		toSerialize["connectionResult"] = o.ConnectionResult.Get()
	}
	return toSerialize, nil
}

type NullableWriterDebugResponseAllOf struct {
	value *WriterDebugResponseAllOf
	isSet bool
}

func (v NullableWriterDebugResponseAllOf) Get() *WriterDebugResponseAllOf {
	return v.value
}

func (v *NullableWriterDebugResponseAllOf) Set(val *WriterDebugResponseAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableWriterDebugResponseAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableWriterDebugResponseAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWriterDebugResponseAllOf(val *WriterDebugResponseAllOf) *NullableWriterDebugResponseAllOf {
	return &NullableWriterDebugResponseAllOf{value: val, isSet: true}
}

func (v NullableWriterDebugResponseAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWriterDebugResponseAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
